﻿using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc.Html;
using System.Web.UI;
using SmartStore.Collections;
using SmartStore.Core.Infrastructure;

namespace SmartStore.Web.Framework.UI
{
    public class MenuRenderer : ComponentRenderer<Menu>
    {
		protected override void WriteHtmlCore(HtmlTextWriter writer)
		{
			var route = Component.Route;

			if (route != null)
			{
				HtmlHelper.RenderAction(route.Action, route.Controller, route.RouteValues);
			}
			else
			{
				HtmlHelper.RenderAction("Menu", "Common", new
				{
					area = "",
					name = Component.Name,
					template = Component.Template
				});
			}
		}

		public override void Render()
		{
			var c = Component;
			var route = c.Route;

			if (route != null)
			{
				HtmlHelper.RenderAction(route.Action, route.Controller, route.RouteValues);
			}
			else
			{
				HtmlHelper.RenderAction("Menu", "Common", new { area = "", name = c.Name, template = c.Template });
			}
		}

		public override string ToHtmlString()
		{
			var c = Component;
			var route = c.Route;

			if (route != null)
			{
				return HtmlHelper.Action(route.Action, route.Controller, route.RouteValues).ToHtmlString();
			}
			else
			{
				return HtmlHelper.Action("Menu", "Common", new { area = "", name = c.Name, template = c.Template }).ToHtmlString();
			}
		}
	}
}
